# e2b.api.v2.client
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The `e2b.api.v2.client` package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage

This python library package is generated without supporting files like setup.py or requirements files

To be able to use it, you will need these dependencies in your own package that uses this library:

* urllib3 >= 1.25.3
* python-dateutil
* pydantic
* aenum

## Getting Started

In your own code, to use this library to connect and interact with e2b.api.v2.client,
you can run the following:

```python

import time
import e2b.api.v2.client
from e2b.api.v2.client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.e2b.dev
# See configuration.py for a list of all supported configuration parameters.
configuration = e2b.api.v2.client.Configuration(
    host = "https://api.e2b.dev"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'


# Enter a context with an instance of the API client
with e2b.api.v2.client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = e2b.api.v2.client.InstancesApi(api_client)
    instance_id = 'instance_id_example' # str | 
    instances_instance_id_refreshes_post_request = e2b.api.v2.client.InstancesInstanceIDRefreshesPostRequest() # InstancesInstanceIDRefreshesPostRequest |  (optional)

    try:
        api_instance.instances_instance_id_refreshes_post(instance_id, instances_instance_id_refreshes_post_request=instances_instance_id_refreshes_post_request)
    except ApiException as e:
        print("Exception when calling InstancesApi->instances_instance_id_refreshes_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.e2b.dev*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*InstancesApi* | [**instances_instance_id_refreshes_post**](e2b/api/v2/client/docs/InstancesApi.md#instances_instance_id_refreshes_post) | **POST** /instances/{instanceID}/refreshes | 
*InstancesApi* | [**instances_post**](e2b/api/v2/client/docs/InstancesApi.md#instances_post) | **POST** /instances | 


## Documentation For Models

 - [Environment](e2b/api/v2/client/docs/Environment.md)
 - [EnvironmentBuild](e2b/api/v2/client/docs/EnvironmentBuild.md)
 - [EnvsEnvIDBuildsBuildIDLogsPostRequest](e2b/api/v2/client/docs/EnvsEnvIDBuildsBuildIDLogsPostRequest.md)
 - [Error](e2b/api/v2/client/docs/Error.md)
 - [Instance](e2b/api/v2/client/docs/Instance.md)
 - [InstancesInstanceIDRefreshesPostRequest](e2b/api/v2/client/docs/InstancesInstanceIDRefreshesPostRequest.md)
 - [NewInstance](e2b/api/v2/client/docs/NewInstance.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="ApiKeyAuth"></a>
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-API-Key
- **Location**: HTTP header

<a id="AccessTokenAuth"></a>
### AccessTokenAuth

- **Type**: Bearer authentication (access_token)


## Author




